#include <Servo.h>
Servo cde;        //Servos zuständig für jeweils die Notengruppe (C,D,E) (F,G,A) (H,C)
Servo fga;
Servo hc;

//Testwerte, damit man beim Testen nicht im ganzen Code rumsuchen muss.
int einPinAn = 2500;      //Ein Phototransistor ist beleuchtet
int keinPinAn = 1200 ;     //Kein Phototransisotr ist beleuchtet


int notenblatt[300];      //Der Array, wo die Noten gespeichert werden.
int tonzahl = 0;          //Zählt die Anzahl der hinzugefügten Noten
int analog_pin[] = {A0, A1, A2, A3, A4, A5, A6, A7};









// Setup: Initialisiert die pins für die Phototransistoren, Hubmagneten, etc.

void setup() {
  Serial.begin(2400);

  for (int i = 0; i < 8; i++) {         //for-loop für alle analogen Pins, die an die jeweiligen Phototransistoren angeschlossen sind.
    pinMode(analog_pin[i], INPUT);
  }

  pinMode(2, OUTPUT);    //Hubmagneten
  pinMode(4, OUTPUT);
  pinMode(7, OUTPUT);

  pinMode(LED_BUILTIN, OUTPUT);      // Arduino blinkt, wenn es gerade ein Ton gelesen hat.

  pinMode(10, INPUT);     //Output (Knopf für das Abspielen von Noten)
  pinMode (9, INPUT);    //Read   (Schalter für das Lesen der Noten)

  cde.attach(3);    //Servos
  fga.attach(5);
  hc.attach(6);

  pinMode(12, OUTPUT);     //Direction
  digitalWrite(12,HIGH);   //Einstellung der Drehrichtung
  pinMode(11, OUTPUT);     //Step (Für den Stepper am Lesestand)
}










//Hier beim loop wird mit jeder Schleife geprüft, was gerade bei dem Knopf und Schalter los ist. Es klappt nur, wenn eine der beiden Eingänge an sind.
//1. Beim Lesen (Schalter an) soll es das Blatt solange nach vorne schieben, bis die erste Note unter dem Phototransistor befindet. Danach wird das die Methode für das ablesen für jede Note durchgeführt. Leider.
//Dabei wird immer geprüft, ob wirklich nur ein Phototransistor beleuchtet wird oder nicht.
//Bei dem Knopfdruck wird das, was bisher aufgenommen wurde, gespielt.
//Ansonsten gibt des auf dem Serial Monitor Fehlermeldungen aus.

void loop() {
//  Serial.println(analogRead(4));          //Tester
  if (digitalRead(9) == HIGH && digitalRead(10) == LOW) {
    while ((holInputSumme() > einPinAn || holInputSumme() < keinPinAn) && digitalRead(9) == HIGH) {
      digitalWrite(11, HIGH);
      delay(3);
      digitalWrite(11, LOW);
      delay(3);
    }
    if (holInputSumme() < einPinAn && holInputSumme() > keinPinAn) {
      for (int i = 1; i <= 8; i++) {
        ablesen(i);
        digitalWrite(LED_BUILTIN, LOW);
      }
    }
  } else if (digitalRead(9) == LOW && digitalRead(10) == HIGH) {
    ausgeben();   //Test
       abspielen();
  } else if (digitalRead(9) == LOW && digitalRead(10) == LOW) {
    Serial.println("Bitte eine Aktion waehlen");
  } else if (digitalRead(9) == HIGH && digitalRead(10) == HIGH) {
    Serial.println("Bitte nur eine Aktion waehlen");
  }
}








//Gibt den Gesamtwert aller Phototransistoren an (Besser als Methode als Variable, da es immer aktuell ist.)

int holInputSumme() {
  return analogRead(A0) + analogRead(A1) + analogRead(A2) + analogRead(A3) + analogRead(A4) + analogRead(A5) + analogRead(A6) + analogRead(A7);
}







//Hier wird grprüft, ob wirklich nur der zugehörige Phototransistor beleuchtet wird (erstes IF) Bei Zeile 91(zweites IF) wird ausgenutzt, dass die Arraybezeichnungen von einer Note die Note - 1 ist. 
//Beim 3. IF wird dann wirklich gelesen und die LED leuchtet, wenn alles gut geht.
//Danach soll der Stepper solange weiterschieben, bis die Phototransistoren keinen Licht mehr empfangen (Leerstelle zwischen den Noten) Danach wird der Code in der loop funktion weiterschieben.

void ablesen(int note) {
  if (holInputSumme() < einPinAn) {
    boolean anderePins = true;
    for (int i = 0; i < 8; i++) {
      if (i != note - 1) {
        anderePins = anderePins || analogRead(analog_pin[i]) < 500;
      }
    }
    if (analogRead(analog_pin[note - 1]) > 500 && anderePins) {
      notenblatt[tonzahl] = note;
      tonzahl++;
      digitalWrite(LED_BUILTIN, HIGH);
      delay(1000);
      while (holInputSumme() < einPinAn && holInputSumme() > keinPinAn) {
        digitalWrite(11, HIGH);
        delay(3);
        digitalWrite(11, LOW);
        delay(3);
      }
      delay(1000);
    }
  }
}






//Einfach ausgeben (Für die Überprüfung, ob alles gut gelaufen ist.)

void ausgeben() {
  for (int i = 0; i < tonzahl; i++) {
    Serial.println(notenblatt[i]);
  }
}








//Hier wird der Array "notenblatt" abgelesen und gespielt . Es liest nur bis zur variable tonzahl, was beim Lesen mitgezählt hat.
//Ansonsten wird hier anstatt if switch für die Übersichtlichekeit benutzt, Wobei jedes case den Servo im richigen Winkel stellt, wonach der Hubmagnet schlägt.
//Am Ende jeder Note wird das Blatt weitergeschoben, bis es an eine Stelle kommt, wo es

int x = 500;    //Pause für den Hubmagneten
int y = 400;    //Pause zwischen das Spielen der Noten

void abspielen() {
  for (int i = 1; i < tonzahl; i++) {
    switch (notenblatt[i]) {
      case (1):
        cde.write(109);
        delay(200);
        digitalWrite(2, HIGH);
        delay(x);          
        digitalWrite(2, LOW);
        delay(y);
        break;
      case (2):
        cde.write(98);
        delay(200);
        digitalWrite(2, HIGH);
        delay(x);          
        digitalWrite(2, LOW);
        delay(y);
        break;
      case (3):
        cde.write(85);
        delay(200);
        digitalWrite(2, HIGH);
        delay(x);          
        digitalWrite(2, LOW);
        delay(y);
        break;
      case (4):
        fga.write(107);
        delay(200);
        digitalWrite(4, HIGH);
        delay(x);
        digitalWrite(4, LOW);
        delay(x);
        break;
      case (5):
        fga.write(98);
        delay(200);
        digitalWrite(4, HIGH);
        delay(x);
        digitalWrite(4, LOW);
        delay(y);
        break;
      case (6):
        fga.write(85);
        delay(200);
        digitalWrite(4, HIGH);
        delay(x);
        digitalWrite(4, LOW);
        delay(y);
        break;
      case (8):
        hc.write(93);
        delay(200);
        digitalWrite(7, HIGH);
        delay(x);
        digitalWrite(7, LOW);
        delay(y);
        break;
      case (7):
        hc.write(103);
        delay(200);
        digitalWrite(7, HIGH);
        delay(x);
        digitalWrite(7, LOW);
        delay(y);
        break;
    }
  }
}
